Token (Lucene 3.6.2 API)
Keywords: org.apache.lucene.analysis.Token class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.analysis
Class Token

    java.lang.Object
      org.apache.lucene.util.AttributeImpl
          org.apache.lucene.analysis.tokenattributes.CharTermAttributeImpl
              org.apache.lucene.analysis.tokenattributes.TermAttributeImpl
                  org.apache.lucene.analysis.Token

All Implemented Interfaces:
  Serializable, Appendable, CharSequence, Cloneable, CharTermAttribute, FlagsAttribute, OffsetAttribute, PayloadAttribute, PositionIncrementAttribute, PositionLengthAttribute, TermAttribute, TypeAttribute, Attribute

    public class Token

extends TermAttributeImpl
implements TypeAttribute, PositionIncrementAttribute, FlagsAttribute, OffsetAttribute, PayloadAttribute, PositionLengthAttribute

A Token is an occurrence of a term from the text of a field. It consists of a term's text, the start and end offset of the term in the text of the field, and a type string.

The start and end offsets permit applications to re-associate a token with its source text, e.g., to display highlighted query terms in a document browser, or to show matching text fragments in a KWIC display, etc.

The type is a string, assigned by a lexical analyzer (a.k.a. tokenizer), naming the lexical or syntactic class that the token belongs to. For example an end of sentence marker token might be implemented with type "eos". The default token type is "word".

A Token can optionally have metadata (a.k.a. Payload) in the form of a variable length byte array. Use `TermPositions.getPayloadLength()` and `TermPositions.getPayload(byte[], int)` to retrieve the payloads from the index.

NOTE: As of 2.9, Token implements all `Attribute` interfaces that are part of core Lucene and can be found in the `tokenattributes` subpackage. Even though it is not necessary to use Token anymore, with the new TokenStream API it can be used as convenience class that implements all `Attribute`s, which is especially useful to easily switch from the old to the new TokenStream API.

Tokenizers and TokenFilters should try to re-use a Token instance when possible for best performance, by implementing the `TokenStream.incrementToken()` API. Failing that, to create a new Token you should first use one of the constructors that starts with null text. To load the token from a char[] use `CharTermAttributeImpl.copyBuffer(char[], int, int)`. To load from a String use `CharTermAttributeImpl.setEmpty()` followed by `CharTermAttributeImpl.append(CharSequence)` or `CharTermAttributeImpl.append(CharSequence, int, int)`. Alternatively you can get the Token's termBuffer by calling either `CharTermAttributeImpl.buffer()`, if you know that your text is shorter than the capacity of the termBuffer or `CharTermAttributeImpl.resizeBuffer(int)`, if there is any possibility that you may need to grow the buffer. Fill in the characters of your term into this buffer, with `String.getChars(int, int, char[], int)` if loading from a string, or with `System.arraycopy(Object, int, Object, int, int)`, and finally call `CharTermAttributeImpl.setLength(int)` to set the length of the term text. See LUCENE-969 for details.

Typical Token reuse patterns:

- Copying text from a string (type is reset to `TypeAttribute.DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(string, startOffset, endOffset[, type]);

- Copying some text from a string (type is reset to `TypeAttribute.DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(string, 0, string.length(), startOffset, endOffset[, type]);

- Copying text from char[] buffer (type is reset to `TypeAttribute.DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(buffer, 0, buffer.length, startOffset, endOffset[, type]);

- Copying some text from a char[] buffer (type is reset to `TypeAttribute.DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(buffer, start, end - start, startOffset, endOffset[, type]);

- Copying from one one Token to another (type is reset to `TypeAttribute.DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(source.buffer(), 0, source.length(), source.startOffset(), source.endOffset()[, source.type()]);

A few things to note:

- clear() initializes all of the fields to default values. This was changed in contrast to Lucene 2.4, but should affect no one.
- Because `TokenStreams` can be chained, one cannot assume that the `Token's` current type is correct.
- The startOffset and endOffset represent the start and offset in the source text, so be careful in adjusting them.
- When caching a reusable token, clone it. When injecting a cached token into a stream that can be reset, clone it again.

Please note: With Lucene 3.1, the `toString()` method had to be changed to match the `CharSequence` interface introduced by the interface `CharTermAttribute`. This method now only prints the term text, no additional information anymore.

See Also:
  `Payload`, Serialized Form

Nested Class Summary
`static class` | `Token.TokenAttributeFactory` Expert: Creates a TokenAttributeFactory returning `Token` as instance for the basic attributes and for all other attributes calls the given delegate factory.

Field Summary
`static AttributeSource.AttributeFactory` | `TOKEN_ATTRIBUTE_FACTORY` Convenience factory that returns `Token` as implementation for the basic attributes and return the default impl (with "Impl" appended) for all other attributes.

Fields inherited from class org.apache.lucene.util.AttributeImpl
`enableBackwards`

Fields inherited from interface org.apache.lucene.analysis.tokenattributes.TypeAttribute
`DEFAULT_TYPE`

Constructor Summary
`Token()` Constructs a Token will null text.
`Token(char[] startTermBuffer, int termBufferOffset, int termBufferLength, int start, int end)` Constructs a Token with the given term buffer (offset & length), start and end offsets
`Token(int start, int end)` Constructs a Token with null text and start & end offsets.
`Token(int start, int end, int flags)` Constructs a Token with null text and start & end offsets plus flags.
`Token(int start, int end, String typ)` Constructs a Token with null text and start & end offsets plus the Token type.
`Token(String text, int start, int end)` Constructs a Token with the given term text, and start & end offsets.
`Token(String text, int start, int end, int flags)` Constructs a Token with the given text, start and end offsets, & type.
`Token(String text, int start, int end, String typ)` Constructs a Token with the given text, start and end offsets, & type.

Method Summary
`void` | `clear()` Resets the term text, payload, flags, and positionIncrement, startOffset, endOffset and token type to default.
`Object` | `clone()` Shallow clone.
`Token` | `clone(char[] newTermBuffer, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset)` Makes a clone, but replaces the term buffer & start/end offset in the process.
`void` | `copyTo(AttributeImpl target)` Copies the values from this Attribute into the passed-in target attribute.
`int` | `endOffset()` Returns this Token's ending offset, one greater than the position of the last character corresponding to this token in the source text.
`boolean` | `equals(Object obj)`
`int` | `getFlags()` Get the bitset for any bits that have been set.
`Payload` | `getPayload()` Returns this Token's payload.
`int` | `getPositionIncrement()` Returns the position increment of this Token.
`int` | `getPositionLength()` Get the position length.
`int` | `hashCode()`
`void` | `reflectWith(AttributeReflector reflector)` This method is for introspection of attributes, it should simply add the key/values this attribute holds to the given `AttributeReflector`.
`Token` | `reinit(char[] newTermBuffer, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset)` Shorthand for calling `clear()`, `CharTermAttributeImpl.copyBuffer(char[], int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE
`Token` | `reinit(char[] newTermBuffer, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset, String newType)` Shorthand for calling `clear()`, `CharTermAttributeImpl.copyBuffer(char[], int, int)`, `setStartOffset(int)`, `setEndOffset(int)`, `setType(java.lang.String)`
`Token` | `reinit(String newTerm, int newStartOffset, int newEndOffset)` Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE
`Token` | `reinit(String newTerm, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset)` Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence, int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE
`Token` | `reinit(String newTerm, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset, String newType)` Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence, int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)`
`Token` | `reinit(String newTerm, int newStartOffset, int newEndOffset, String newType)` Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)`
`void` | `reinit(Token prototype)` Copy the prototype token's fields into this one.
`void` | `reinit(Token prototype, char[] newTermBuffer, int offset, int length)` Copy the prototype token's fields into this one, with a different term.
`void` | `reinit(Token prototype, String newTerm)` Copy the prototype token's fields into this one, with a different term.
`void` | `setEndOffset(int offset)` Set the ending offset.
`void` | `setFlags(int flags)`
`void` | `setOffset(int startOffset, int endOffset)` Set the starting and ending offset.
`void` | `setPayload(Payload payload)` Sets this Token's payload.
`void` | `setPositionIncrement(int positionIncrement)` Set the position increment.
`void` | `setPositionLength(int positionLength)` Set the position length.
`void` | `setStartOffset(int offset)` Set the starting offset.
`void` | `setType(String type)` Set the lexical type.
`int` | `startOffset()` Returns this Token's starting offset, the position of the first character corresponding to this token in the source text.
`String` | `type()` Returns this Token's lexical type.

Methods inherited from class org.apache.lucene.analysis.tokenattributes.CharTermAttributeImpl
`append, append, append, append, append, append, buffer, charAt, copyBuffer, length, resizeBuffer, resizeTermBuffer, setEmpty, setLength, setTermBuffer, setTermBuffer, setTermBuffer, setTermLength, subSequence, term, termBuffer, termLength, toString`

Methods inherited from class org.apache.lucene.util.AttributeImpl
`reflectAsString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### TOKEN_ATTRIBUTE_FACTORY

    public static final AttributeSource.AttributeFactory TOKEN_ATTRIBUTE_FACTORY

  Convenience factory that returns `Token` as implementation for the basic attributes and return the default impl (with "Impl" appended) for all other attributes.

  Since:
    3.0

Constructor Detail

### Token

    public Token()

  Constructs a Token will null text.

### Token

    public Token(int start,
                 int end)

  Constructs a Token with null text and start & end offsets.

  Parameters:
    `start` - start offset in the source text
    `end` - end offset in the source text

### Token

    public Token(int start,
                 int end,
                 String typ)

  Constructs a Token with null text and start & end offsets plus the Token type.

  Parameters:
    `start` - start offset in the source text
    `end` - end offset in the source text
    `typ` - the lexical type of this Token

### Token

    public Token(int start,
                 int end,
                 int flags)

  Constructs a Token with null text and start & end offsets plus flags. NOTE: flags is EXPERIMENTAL.

  Parameters:
    `start` - start offset in the source text
    `end` - end offset in the source text
    `flags` - The bits to set for this token

### Token

    public Token(String text,
                 int start,
                 int end)

  Constructs a Token with the given term text, and start & end offsets. The type defaults to "word." NOTE: for better indexing speed you should instead use the char[] termBuffer methods to set the term text.

  Parameters:
    `text` - term text
    `start` - start offset
    `end` - end offset

### Token

    public Token(String text,
                 int start,
                 int end,
                 String typ)

  Constructs a Token with the given text, start and end offsets, & type. NOTE: for better indexing speed you should instead use the char[] termBuffer methods to set the term text.

  Parameters:
    `text` - term text
    `start` - start offset
    `end` - end offset
    `typ` - token type

### Token

    public Token(String text,
                 int start,
                 int end,
                 int flags)

  Constructs a Token with the given text, start and end offsets, & type. NOTE: for better indexing speed you should instead use the char[] termBuffer methods to set the term text.

  Parameters:
    `text` -
    `start` -
    `end` -
    `flags` - token type bits

### Token

    public Token(char[] startTermBuffer,
                 int termBufferOffset,
                 int termBufferLength,
                 int start,
                 int end)

  Constructs a Token with the given term buffer (offset & length), start and end offsets

  Parameters:
    `startTermBuffer` -
    `termBufferOffset` -
    `termBufferLength` -
    `start` -
    `end` -

Method Detail

### setPositionIncrement

    public void setPositionIncrement(int positionIncrement)

  Set the position increment. This determines the position of this token relative to the previous Token in a `TokenStream`, used in phrase searching.

  The default value is one.

  Some common uses for this are:

  - Set it to zero to put multiple terms in the same position. This is useful if, e.g., a word has multiple stems. Searches for phrases including either stem will match. In this case, all but the first stem's increment should be set to zero: the increment of the first instance should be one. Repeating a token with an increment of zero can also be used to boost the scores of matches on that token.
  - Set it to values greater than one to inhibit exact phrase matches. If, for example, one does not want phrases to match across removed stop words, then one could build a stop word filter that removes stop words and also sets the increment to the number of stop words removed before each non-stop word. Then exact phrase queries will only match when the terms occur with no intervening stop words.

  Specified by:
    `setPositionIncrement` in interface `PositionIncrementAttribute`
  Parameters:
    `positionIncrement` - the distance from the prior term
  See Also:
    `TermPositions`

### getPositionIncrement

    public int getPositionIncrement()

  Returns the position increment of this Token.

  Specified by:
    `getPositionIncrement` in interface `PositionIncrementAttribute`
  See Also:
    `setPositionIncrement(int)`

### setPositionLength

    public void setPositionLength(int positionLength)

  Set the position length.

  Specified by:
    `setPositionLength` in interface `PositionLengthAttribute`
  Parameters:
    `positionLength` - how many positions this token spans.
  See Also:
    `PositionLengthAttribute`

### getPositionLength

    public int getPositionLength()

  Get the position length.

  Specified by:
    `getPositionLength` in interface `PositionLengthAttribute`
  See Also:
    `PositionLengthAttribute`

### startOffset

    public final int startOffset()

  Returns this Token's starting offset, the position of the first character corresponding to this token in the source text. Note that the difference between endOffset() and startOffset() may not be equal to `CharTermAttributeImpl.length()`, as the term text may have been altered by a stemmer or some other filter.

  Specified by:
    `startOffset` in interface `OffsetAttribute`

### setStartOffset

    public void setStartOffset(int offset)

  Set the starting offset.

  See Also:
    `startOffset()`

### endOffset

    public final int endOffset()

  Returns this Token's ending offset, one greater than the position of the last character corresponding to this token in the source text. The length of the token in the source text is (endOffset - startOffset).

  Specified by:
    `endOffset` in interface `OffsetAttribute`

### setEndOffset

    public void setEndOffset(int offset)

  Set the ending offset.

  See Also:
    `endOffset()`

### setOffset

    public void setOffset(int startOffset,
                          int endOffset)

  Set the starting and ending offset.

  Specified by:
    `setOffset` in interface `OffsetAttribute`
  See Also:
    `and #endOffset()`

### type

    public final String type()

  Returns this Token's lexical type. Defaults to "word".

  Specified by:
    `type` in interface `TypeAttribute`

### setType

    public final void setType(String type)

  Set the lexical type.

  Specified by:
    `setType` in interface `TypeAttribute`
  See Also:
    `type()`

### getFlags

    public int getFlags()

  Get the bitset for any bits that have been set. This is completely distinct from `type()`, although they do share similar purposes. The flags can be used to encode information about the token for use by other `TokenFilter`s.

  Specified by:
    `getFlags` in interface `FlagsAttribute`
  Returns:
    The bits
  WARNING: This API is experimental and might change in incompatible ways in the next release.
    While we think this is here to stay, we may want to change it to be a long.

### setFlags

    public void setFlags(int flags)

  Specified by:
    `setFlags` in interface `FlagsAttribute`
  See Also:
    `getFlags()`

### getPayload

    public Payload getPayload()

  Returns this Token's payload.

  Specified by:
    `getPayload` in interface `PayloadAttribute`

### setPayload

    public void setPayload(Payload payload)

  Sets this Token's payload.

  Specified by:
    `setPayload` in interface `PayloadAttribute`

### clear

    public void clear()

  Resets the term text, payload, flags, and positionIncrement, startOffset, endOffset and token type to default.

  Overrides:
    `clear` in class `CharTermAttributeImpl`

### clone

    public Object clone()

  Description copied from class: `AttributeImpl`
  Shallow clone. Subclasses must override this if they need to clone any members deeply,

  Overrides:
    `clone` in class `CharTermAttributeImpl`

### clone

    public Token clone(char[] newTermBuffer,
                       int newTermOffset,
                       int newTermLength,
                       int newStartOffset,
                       int newEndOffset)

  Makes a clone, but replaces the term buffer & start/end offset in the process. This is more efficient than doing a full clone (and then calling `CharTermAttributeImpl.copyBuffer(char[], int, int)`) because it saves a wasted copy of the old termBuffer.

### equals

    public boolean equals(Object obj)

  Overrides:
    `equals` in class `CharTermAttributeImpl`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `CharTermAttributeImpl`

### reinit

    public Token reinit(char[] newTermBuffer,
                        int newTermOffset,
                        int newTermLength,
                        int newStartOffset,
                        int newEndOffset,
                        String newType)

  Shorthand for calling `clear()`, `CharTermAttributeImpl.copyBuffer(char[], int, int)`, `setStartOffset(int)`, `setEndOffset(int)`, `setType(java.lang.String)`

  Returns:
    this Token instance

### reinit

    public Token reinit(char[] newTermBuffer,
                        int newTermOffset,
                        int newTermLength,
                        int newStartOffset,
                        int newEndOffset)

  Shorthand for calling `clear()`, `CharTermAttributeImpl.copyBuffer(char[], int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE

  Returns:
    this Token instance

### reinit

    public Token reinit(String newTerm,
                        int newStartOffset,
                        int newEndOffset,
                        String newType)

  Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)`

  Returns:
    this Token instance

### reinit

    public Token reinit(String newTerm,
                        int newTermOffset,
                        int newTermLength,
                        int newStartOffset,
                        int newEndOffset,
                        String newType)

  Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence, int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)`

  Returns:
    this Token instance

### reinit

    public Token reinit(String newTerm,
                        int newStartOffset,
                        int newEndOffset)

  Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE

  Returns:
    this Token instance

### reinit

    public Token reinit(String newTerm,
                        int newTermOffset,
                        int newTermLength,
                        int newStartOffset,
                        int newEndOffset)

  Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence, int, int)`, `setStartOffset(int)`, `setEndOffset(int)` `setType(java.lang.String)` on Token.DEFAULT_TYPE

  Returns:
    this Token instance

### reinit

    public void reinit(Token prototype)

  Copy the prototype token's fields into this one. Note: Payloads are shared.

  Parameters:
    `prototype` -

### reinit

    public void reinit(Token prototype,
                       String newTerm)

  Copy the prototype token's fields into this one, with a different term. Note: Payloads are shared.

  Parameters:
    `prototype` -
    `newTerm` -

### reinit

    public void reinit(Token prototype,
                       char[] newTermBuffer,
                       int offset,
                       int length)

  Copy the prototype token's fields into this one, with a different term. Note: Payloads are shared.

  Parameters:
    `prototype` -
    `newTermBuffer` -
    `offset` -
    `length` -

### copyTo

    public void copyTo(AttributeImpl target)

  Description copied from class: `AttributeImpl`
  Copies the values from this Attribute into the passed-in target attribute. The target implementation must support all the Attributes this implementation supports.

  Overrides:
    `copyTo` in class `CharTermAttributeImpl`

### reflectWith

    public void reflectWith(AttributeReflector reflector)

  Description copied from class: `AttributeImpl`
  This method is for introspection of attributes, it should simply add the key/values this attribute holds to the given `AttributeReflector`.

  The default implementation calls `AttributeReflector.reflect(java.lang.Class, java.lang.String, java.lang.Object)` for all non-static fields from the implementing class, using the field name as key and the field value as value. The Attribute class is also determined by reflection. Please note that the default implementation can only handle single-Attribute implementations.

  Custom implementations look like this (e.g. for a combined attribute implementation):

         public void reflectWith(AttributeReflector reflector) {
           reflector.reflect(CharTermAttribute.class, "term", term());
           reflector.reflect(PositionIncrementAttribute.class, "positionIncrement", getPositionIncrement());
         }

  If you implement this method, make sure that for each invocation, the same set of `Attribute` interfaces and keys are passed to `AttributeReflector.reflect(java.lang.Class, java.lang.String, java.lang.Object)` in the same order, but possibly different values. So don't automatically exclude e.g. `null` properties!

  Overrides:
    `reflectWith` in class `CharTermAttributeImpl`
  See Also:
    `AttributeImpl.reflectAsString(boolean)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD